## loopino 0.5.0

=== Makefile ===

include libxputty/Build/Makefile.base

NOGOAL := mod install all features clap vst2

SWITCHGOAL := clap vst2

PASS := features 

SUBDIR := Loopino

.PHONY: $(SUBDIR) libxputty rubberband recurse 

$(MAKECMDGOALS) recurse: $(SUBDIR)

check-and-reinit-submodules :
ifeq (,$(filter $(NOGOAL),$(MAKECMDGOALS)))
ifeq (,$(findstring clean,$(MAKECMDGOALS)))
	@if git submodule status 2>/dev/null | egrep -q '^[-]|^[+]' ; then \
		echo "$(red)INFO: Need to reinitialize git submodules$(reset)"; \
		git submodule update --init; \
		echo "$(blue)Done$(reset)"; \
	else echo "$(blue)Submodule up to date$(reset)"; \
	fi
endif
endif

libxputty: check-and-reinit-submodules
ifeq (,$(filter $(NOGOAL),$(MAKECMDGOALS)))
ifeq (,$(wildcard ./libxputty/xputty/resources/dir.png))
	@cp ./Loopino/Resources/*.png ./libxputty/xputty/resources/
endif
	@exec $(MAKE) --no-print-directory -j 1 -C $@ $(MAKECMDGOALS)
endif
ifneq (,$(filter $(SWITCHGOAL),$(MAKECMDGOALS)))
ifeq (,$(wildcard ./libxputty/xputty/resources/dir.png))
	@cp ./Loopino/Resources/*.png ./libxputty/xputty/resources/
endif
	@exec $(MAKE) --no-print-directory -j 1 -C $@ all
endif

rubberband:
ifeq (,$(filter $(PASS),$(MAKECMDGOALS)))
	@exec $(MAKE) --no-print-directory -j 1 -f Makefile.rubberband $(MAKECMDGOALS)
endif

$(SUBDIR): libxputty rubberband
ifeq (,$(filter $(PASS),$(MAKECMDGOALS)))
	@exec $(MAKE) --no-print-directory -j 1 -C $@ $(MAKECMDGOALS)
endif

clean:
	@rm -f ./libxputty/xputty/resources/dir.png
	@rm -f ./libxputty/xputty/resources/exit_.png
	@rm -f ./libxputty/xputty/resources/load_.png
	@rm -f ./libxputty/xputty/resources/save_.png
	@rm -f ./libxputty/xputty/resources/play.png
	@rm -f ./libxputty/xputty/resources/clip_.png
	@rm -f ./libxputty/xputty/resources/quit.png
	@rm -f ./libxputty/xputty/resources/loop.png
	@rm -f ./libxputty/xputty/resources/okay.png
	@rm -f ./libxputty/xputty/resources/plus.png
	@rm -f ./libxputty/xputty/resources/loopino.png
	@rm -f ./libxputty/xputty/resources/presets.png
	@rm -f ./libxputty/xputty/resources/record.png
	@rm -f ./libxputty/xputty/resources/prev.png
	@rm -f ./libxputty/xputty/resources/next.png


features:

=== Loopino/Makefile ===

	STRIP ?= strip

	# check on which OS we build
	UNAME_S := $(shell uname -s)

# get flags supported by CPU
ifeq ($(UNAME_S), FreeBSD)
  CPU_INFO = dmesg | grep Features | tr A-Z a-z
  ifeq ($(UNAME_M), amd64)
    UNAME_M = x86_64
  endif
else
  CPU_INFO = cat /proc/cpuinfo | grep flags
endif

ifeq ($(MAKECMDGOALS),debug)
  CXXFLAGS += -g -DDEBUG
else
  CXXFLAGS += -O2 -DNDEBUG
endif

ifneq ($(MAKECMDGOALS),clap)
  ifneq ($(MAKECMDGOALS),vst2)
    ifeq ($(TARGET), Linux)
      USEAPI = jack
      LDFLAGS += -lasound
    endif
  endif
endif

	# check CPU and supported optimization flags
	ifneq ($$(filter $(CPU_INFO) | grep sse3 ) , )
		SSE_CFLAGS = -msse3 -mfpmath=sse
	else ifneq ($$(filter $(CPU_INFO) | grep sse2 ) , )
		SSE_CFLAGS = -msse2 -mfpmath=sse
	else ifneq ($$(filter $(CPU_INFO) | grep sse ) , )
		SSE_CFLAGS = -msse -mfpmath=sse
	else ifneq ($$(filter $(CPU_INFO) | grep ARM ) , )
		ifneq ($$$(filter $(CPU_INFO)  | grep ARMv7 ) , )
			ifneq ($$(filter $(CPU_INFO) | grep vfpd32 ) , )
				SSE_CFLAGS = -march=armv7-a -mfpu=vfpv3
			else ifneq ($$(filter $(CPU_INFO) | grep vfpv3 ) , )
				SSE_CFLAGS = -march=armv7-a -mfpu=vfpv3
			endif
		else
			ARMCPU = "YES"
		endif
	else
		SSE_CFLAGS =
	endif

	# set bundle name
	NAME = loopino
	VER = 0.1

	PREFIX ?= /usr
	# check if user is root
	user = $(shell whoami)
	ifeq ($(user),root)
	INSTALL_DIR ?= $(PREFIX)/lib/lv2
	EXE_INSTALL_DIR ?= $(PREFIX)/bin
	CLAP_INSTAL_DIR ?= $(PREFIX)/lib/clap
	VST2_INSTAL_DIR ?= $(PREFIX)/lib/vst
	else 
	INSTALL_DIR ?= ~/.lv2
	EXE_INSTALL_DIR ?= ~/bin
	CLAP_INSTAL_DIR ?= ~/.clap
	VST2_INSTAL_DIR ?= ~/.vst
	endif

	SHARE_DIR ?= $(PREFIX)/share
	DESKAPPS_DIR ?= $(SHARE_DIR)/applications
	PIXMAPS_DIR ?= $(SHARE_DIR)/pixmaps

	LIB_DIR := ../libxputty/libxputty/
	HEADER_DIR := $(LIB_DIR)include/
	RESOURCES := $(wildcard $(RESOURCES_DIR)*.png)

	CLAP_DIR := ./Clap/
	CLAP_INCLUDE := -I. -I./Clap/clap/ -I./Clap/
	CLAP_SOURCES := $(CLAP_DIR)ClapPlug.cpp

	VST2_DIR := ./vst2/
	VST2_INCLUDE := -I. -I./vst2/ -I./Clap/
	VST2_SOURCES := $(VST2_DIR)Loopinovst.cpp

ifeq ($(TARGET), Linux)
	# set compile flags
	CFLAGS += -Wall -funroll-loops `$(PKGCONFIG) $(PKGCONFIG_FLAGS) --cflags sndfile $(USEAPI) fftw3f `\
	-ffast-math -fomit-frame-pointer -fstrength-reduce -fdata-sections \
	-pthread $(SSE_CFLAGS)
	CXXFLAGS += -MMD -std=c++17 -fPIC -D_OS_UNIX_ -DALVER=\"$(VER)\" $(CFLAGS)
	LDFLAGS += -I. -I./Machines/ -I./Filter/ -I./Backends/ -lm -pthread -lpthread -lstdc++ \
	-I../rubberband/ -I../rubberband/rubberband/ -L. ../rubberband/lib/librubberband.$(STATIC_LIB_EXT) \
	`$(PKGCONFIG) $(PKGCONFIG_FLAGS) --libs sndfile $(USEAPI) fftw3f `
	ifneq ($(MACOS)$(WINDOWS),true)
		LDFLAGS += -lrt -lc
	endif
	ifneq (,$(findstring clang, $(CXX)))
		CXXFLAGS := $(filter-out -fstrength-reduce,$(CXXFLAGS))
		CXXFLAGS += -Wno-unused-private-field
	endif
	GUI_LDFLAGS += -I. -I$(HEADER_DIR) -Wl,--gc-sections \
	-L. $(LIB_DIR)libxputty.a  `$(PKGCONFIG) $(PKGCONFIG_FLAGS) --cflags --libs cairo x11` -lm
else ifeq ($(TARGET), Windows)

	CXXFLAGS += -MMD -std=c++17 -fPIC -DALVER=\"$(VER)\" $(CFLAGS)

	LDFLAGS += -I. -I./Machines/ -I./Filter/ -I./Backends/ -lm -pthread -lpthread  $(PAWPAW_LFLAGS) \
	`$(PKGCONFIG) --cflags --libs $(USEAPI) sndfile fftw3f ` \
	-I../rubberband/ -I../rubberband/rubberband/ -L. ../rubberband/lib/librubberband.$(STATIC_LIB_EXT)

	GUI_LDFLAGS += -I$(HEADER_DIR) -static-libgcc -static-libstdc++ \
	`$(PKGCONFIG) $(PKGCONFIG_FLAGS) --cflags --libs cairo ` \
	-L. $(LIB_DIR)libxputty.$(STATIC_LIB_EXT) -lm $(PAWPAW_LFLAGS)

	CFLAGS += -Wall -funroll-loops `$(PKGCONFIG) --cflags $(USEAPI) sndfile fftw3f`\
	-ffast-math -fomit-frame-pointer -fstrength-reduce -fdata-sections -Wl,--gc-sections \
	-pthread $(SSE_CFLAGS)

	EXE := .exe
endif


	# invoke build files
	OBJECTS = main.cpp

	DEPS = loopino.d

.PHONY : mod all clean install uninstall info

ifeq ($(TARGET), Linux)
all : check $(NAME)
	$(QUIET)mkdir -p ../bin
	$(QUIET)cp ./$(NAME)$(EXE) ../bin
	@if ! [ -f ../bin/$(NAME)$(EXE) ]; then \
		$(R_ECHO) "Sorry, build fail$(reset)"; \
	fi
else
all: clap
endif

debug : all


clap: $(NAME).clap
	$(QUIET)mkdir -p ../bin/
	$(QUIET)cp ./$(NAME).clap ../bin/
	@$(B_ECHO) "=================== DONE =======================$(reset)"

vst2: $(NAME)vst.$(LIB_EXT)
	$(QUIET)mkdir -p ../bin/
	$(QUIET)cp ./$(NAME)vst.$(LIB_EXT) ../bin/
	@$(B_ECHO) "=================== DONE =======================$(reset)"

-include $(DEPS)

check :
ifdef ARMCPU
	@$(R_ECHO)"ARM CPU DEDECTED, please check the optimization flags$(reset)"
endif

info:
	$(info $(yellow) INFO: $(reset) cxxflags $(blue) $(CXX) $(CXXFLAGS) $(reset))
	$(info $(yellow) INFO: $(reset) ldflags  $(blue) $(LD) $(LDFLAGS) $(GUI_LDFLAGS))
	@$(B_ECHO) "=================== INFO =======================$(reset)"


clean :
	$(QUIET)rm -f *.o *.d *.a *.lib 
	$(QUIET)rm -f $(NAME).exe $(NAME) $(NAME).clap $(NAME)vst.$(LIB_EXT)
	$(QUIET)rm -rf ../bin

dist-clean :

install :
ifneq ("$(wildcard ../bin/$(NAME)$(EXE))","")
	$(QUIET)mkdir -p $(DESTDIR)$(EXE_INSTALL_DIR)
	$(QUIET)cp ./$(BUILD_DIR)/$(NAME) $(DESTDIR)$(EXE_INSTALL_DIR)/$(NAME)
  ifeq ($(user),root)
	$(QUIET)mkdir -p $(DESTDIR)$(DESKAPPS_DIR)
	$(QUIET)cp $(NAME).desktop $(DESTDIR)$(DESKAPPS_DIR)/$(NAME).desktop
	$(QUIET)cp $(NAME).svg $(DESTDIR)$(PIXMAPS_DIR)/$(NAME).svg
	$(QUIET)update-desktop-database || true
  endif
else
	@$(B_ECHO) "$(NAME)$(EXE) Standalone skipped$(reset)"
endif
ifneq ("$(wildcard ../bin/$(NAME).clap)","")
	@$(B_ECHO) "Install  $(NAME).clap to $(DESTDIR)$(CLAP_INSTAL_DIR)/$(reset)"
	$(QUIET)mkdir -p $(DESTDIR)$(CLAP_INSTAL_DIR)/
	$(QUIET)cp -r ../bin/$(NAME).clap $(DESTDIR)$(CLAP_INSTAL_DIR)/$(NAME).clap
	@$(B_ECHO) ". ., done$(reset)"
else
	@$(B_ECHO) "$(NAME).clap Clap skipped$(reset)"
endif
ifneq ("$(wildcard ../bin/$(NAME)vst.$(LIB_EXT))","")
	@$(B_ECHO) "Install  $(NAME)vst.$(LIB_EXT) to $(DESTDIR)$(VST2_INSTAL_DIR)/$(reset)"
	$(QUIET)mkdir -p $(DESTDIR)$(VST2_INSTAL_DIR)/
	$(QUIET)cp -r ../bin/$(NAME)vst.$(LIB_EXT) $(DESTDIR)$(VST2_INSTAL_DIR)/$(NAME)vst.$(LIB_EXT)
	@$(B_ECHO) ". ., done$(reset)"
else
	@$(B_ECHO) "$(NAME)vst.$(LIB_EXT) vst2 skipped$(reset)"
endif

uninstall :
	$(QUIET)rm -rf $(DESTDIR)$(EXE_INSTALL_DIR)/$(NAME)
	$(QUIET)rm -rf $(DESTDIR)$(DESKAPPS_DIR)/$(NAME).desktop
	$(QUIET)rm -rf $(DESTDIR)$(PIXMAPS_DIR)/$(NAME).svg
	$(QUIET)rm -rf $(DESTDIR)$(CLAP_INSTAL_DIR)/$(NAME).clap
	$(QUIET)rm -rf $(DESTDIR)$(VST2_INSTAL_DIR)/$(NAME)vst.$(LIB_EXT)

$(NAME).clap: $(CLAP_SOURCES) Loopino_ui.h | info
	@$(B_ECHO) "Compiling $(NAME).clap $(reset)"
	$(QUIET)$(CXX) $(CXXFLAGS) -DPIC -shared $(CLAP_INCLUDE) $(CLAP_SOURCES) -o $(NAME).clap $(GUI_LDFLAGS) $(LDFLAGS)
ifeq (,$(filter yes,$(DEBUG)))
	$(QUIET)$(STRIP) -s -x -X -R .comment -R .note.ABI-tag $(NAME).clap
endif

$(NAME)vst.$(LIB_EXT): $(VST2_SOURCES) Loopino_ui.h | info
	@$(B_ECHO) "Compiling $(NAME)vst.$(LIB_EXT) $(reset)"
	$(QUIET)$(CXX) $(CXXFLAGS) -DPIC -shared -Wno-multichar $(VST2_INCLUDE) $(VST2_SOURCES) -o $(NAME)vst.$(LIB_EXT) $(GUI_LDFLAGS) $(LDFLAGS)
ifeq (,$(filter yes,$(DEBUG)))
	$(QUIET)$(STRIP) -s -x -X -R .comment -R .note.ABI-tag $(NAME)vst.$(LIB_EXT)
endif

$(NAME) : $(OBJECTS) Loopino_ui.h | info
ifeq ($(TARGET), Linux)
	@$(B_ECHO) "Build $@ $(reset)"
	$(QUIET)$(CXX) -MMD $(CXXFLAGS) $(OBJECTS) -o $(NAME)$(EXE) $(LDFLAGS) $(GUI_LDFLAGS)
ifneq ($(MAKECMDGOALS),debug)
	$(QUIET)$(STRIP) -s -x -X -R .note.ABI-tag $(NAME)$(EXE)
endif
	@$(B_ECHO) "=================== DONE =======================$(reset)"
endif
doc:
	#pass

=== libxputty/Makefile ===

include ./Build/Makefile.base

SUBDIR := $(sort $(wildcard */))
SUBDIR := $(filter-out  xputty/, $(SUBDIR))
SUBDIR := $(filter-out  docs/, $(SUBDIR))
SUBDIR := $(filter-out  libxputty/, $(SUBDIR))

GOALS := install uninstall

ifneq ($(filter $(GOALS),$(MAKECMDGOALS)),)
	SUBDIR := $(filter-out  Build/, $(SUBDIR))
endif

.PHONY: $(SUBDIR) recurse

$(MAKECMDGOALS) recurse: $(SUBDIR)

$(SUBDIR):
	@exec $(MAKE) --no-print-directory -C $@ $(MAKECMDGOALS)

doc:
	#@rm -rf ./docs
	#doxygen Doxyfile
	#cp ./examples/index.html ./docs/

install:
	@$(B_ECHO) "================================================$(reset)"

=== libxputty/Build/Makefile ===

	# set  name
	NAME = Xputty
	VER = 1.0

	PREFIX ?= /usr
	INSTALL_DIR ?= $(PREFIX)/lib/
	INCLUDE_DIR ?= $(PREFIX)/include/
	SHARE_DIR ?= $(PREFIX)/share/

	LIB_DIR := ../xputty/
	HEADER_DIR := $(LIB_DIR)header/
	WIDGET_DIR := $(LIB_DIR)widgets/
	WIDGET_HEADER_DIR := $(HEADER_DIR)widgets/
	DIALOG_DIR := $(LIB_DIR)dialogs/
	DIALOG_HEADER_DIR := $(HEADER_DIR)dialogs/
	RESOURCES_DIR :=$(LIB_DIR)resources/
	OBJ_DIR := .
	RELEASE_DIR := ../libxputty/


ifeq ($(PAWPAW_BUILD),1)
	CFLAGS += -DPAWPAW=1
endif

	# include path for library headers
	INCLUDES := -I. -I$(HEADER_DIR) -I$(WIDGET_HEADER_DIR) -I$(RESOURCES_DIR) -I$(DIALOG_HEADER_DIR) -I$(XDG_DIR)
	# link flags to dynamic link cairo and X11 (default)
	LDFLAGS += -fPIC `$(PKGCONFIG) $(PKGCONFIG_FLAGS) --cflags cairo $(XELF)` 
	# set link flags to static link cairo and X11
	# (you could ignore ld warnings, but the resulting binary is huge
	# (6.4Mb for x11 and cairo) NOT RECOMMENDED!!
	STATIC_LDFLAGS += -fPIC -static `pkg-config --static --cflags cairo ` \
	 -lX11 -ldl -lxcb -lpthread -lXau -lXdmcp
	# debug flags, use this to indicate a problem with libxputty
	DEBUG_LDFLAGS += -g -DDEBUG 


	LIB_SOURCES := $(wildcard $(LIB_DIR)*.c)
	LIB_OBJ := $(notdir $(patsubst %.c,%.o,$(LIB_SOURCES)))

	WIDGET_SOURCES := $(wildcard $(WIDGET_DIR)*.c)
	WIDGET_OBJ := $(notdir $(patsubst %.c,%.o,$(WIDGET_SOURCES)))

	DIALOG_SOURCES := $(wildcard $(DIALOG_DIR)*.c)
	DIALOG_OBJ := $(notdir $(patsubst %.c,%.o,$(DIALOG_SOURCES)))

	RESOURCES := $(wildcard $(RESOURCES_DIR)*.png)
	RESOURCES_OBJ := $(notdir $(patsubst %.png,%.o,$(RESOURCES)))
	RESOURCES_C := $(notdir $(patsubst %.png,%.c,$(RESOURCES)))
	RESOURCE_EXTLD := $(notdir $(patsubst %.png,%_png,$(RESOURCES)))
	RESOURCEHEADER := $(RESOURCES_DIR)xresources.h

	SVGRESOURCES := $(wildcard $(RESOURCES_DIR)*.svg)
	SVGRESOURCES_OBJ := $(notdir $(patsubst %.svg,%.o,$(SVGRESOURCES)))
	SVGRESOURCES_C := $(notdir $(patsubst %.svg,%.c,$(SVGRESOURCES)))
	SVGRESOURCE_EXTLD := $(notdir $(patsubst %.svg,%_svg,$(SVGRESOURCES)))

	XDG_SOURCES :=  $(wildcard $(XDG_DIR)*.c)
	XDG_OBJ := $(notdir $(patsubst %.c,%.o,$(XDG_SOURCES)))

	DEP = $(LIB_OBJ:%.o=%.d) $(WIDGET_OBJ:%.o=%.d) $(DIALOG_OBJ:%.o=%.d) $(XDG_OBJ:%.o=%.d)
	CONFIG_H := $(shell cat config.h 2>/dev/null | grep 'USE_LD =' )
	CONFIG_X := $(shell cat config.h 2>/dev/null | grep 'undef' )

ifdef USE_LDD
	RESOURCES_O = $(RESOURCES_OBJ)
else ifdef USE_GOLD
	RESOURCES_O = $(RESOURCES_OBJ)
else
	RESOURCES_O = $(RESOURCES_C)
endif

.PHONY: all clean debug nls updatepot po shared

.NOTPARALLEL:

all: config $(RESOURCEHEADER) libxputty.$(STATIC_LIB_EXT)
	@$(B_ECHO) "=================== DONE =======================$(reset)"

debug: LDFLAGS += $(DEBUG_LDFLAGS)
debug: all

nls: LDFLAGS += -DENABLE_NLS
nls: all

updatepot:
	@:

po:
	@:

clean:
ifndef EXTRAQUIET
	$(QUIET)@$(ECHO) "Clean up $(reset)"
endif
	$(QUIET)rm -f libxputty.$(STATIC_LIB_EXT) libxputty.$(LIB_EXT) libxputty.$(LIB_EXT).1 \
	libxputty.$(LIB_EXT).1.0 libxputty.lib xputty.pc $(RESOURCES_C) $(SVGRESOURCES_C) \
	$(LIB_OBJ) $(WIDGET_OBJ) $(RESOURCES_OBJ) $(SVGRESOURCES_OBJ) $(DIALOG_OBJ) $(XDG_OBJ) $(DEP) $(RESOURCEHEADER)
	$(QUIET)rm -rf $(RELEASE_DIR)
	$(QUIET)rm -f config.h

config:
	@$(B_ECHO) "================================================$(reset)"
ifdef USE_LDD
ifeq (,$(findstring 1,$(CONFIG_H)))
	$(QUIET)@rm -f config.h
	$(QUIET)echo '#ifndef USE_LD' >> config.h ;
	$(QUIET)echo '#define USE_LD = 1' >> config.h ;
	$(QUIET)echo '#endif' >> config.h ;
endif
else ifdef USE_GOLD
ifeq (,$(findstring 1,$(CONFIG_H)))
	$(QUIET)@rm -f config.h
	$(QUIET)echo '#ifndef USE_LD' >> config.h ;
	$(QUIET)echo '#define USE_LD = 1' >> config.h ;
	$(QUIET)echo '#endif' >> config.h ;
endif
else
ifeq (,$(findstring undef,$(CONFIG_X)))
	$(QUIET)@rm -f config.h
	$(QUIET)echo '#ifdef USE_LD' >> config.h ;
	$(QUIET)echo '#undef USE_LD' >> config.h ;
	$(QUIET)echo '#endif' >> config.h ;
endif
endif

$(RESOURCEHEADER): $(RESOURCES_O)
	$(QUIET)rm -f $(RESOURCEHEADER)
	$(QUIET)for f in $(RESOURCE_EXTLD); do \
		echo 'EXTLD('$${f}')' >> $(RESOURCEHEADER) ; \
	done
	$(QUIET)for f in $(SVGRESOURCE_EXTLD); do \
		echo 'extern const char* '$${f}';' >> $(RESOURCEHEADER) ; \
	done

$(XDG_OBJ): $(XDG_SOURCES)
	@$(ECHO) "Building object file $@ $(reset)"
	$(QUIET)$(CC) $(CFLAGS) -MMD -Wall -DHAVE_MMAP -c $(addprefix $(XDG_DIR),$(patsubst %.o,%.c,$@)) -o $@ $(INCLUDES) $(LDFLAGS)

ifdef XXDI
$(RESOURCES_O): $(RESOURCES)
	@$(ECHO) "Building object file for Resources $(reset)"
	$(QUIET)$(foreach f, $(RESOURCES_OBJ), \
		cd $(RESOURCES_DIR) ; \
		$(XXDI) $(patsubst %.o,%.png,$(f)) > ../../Build/$(patsubst %.o,%.c,$(f)) ; \
		cd ../../Build/ ; \
	)
	$(QUIET)$(foreach f, $(RESOURCES_C), \
		$(CC) -c $(f) -o $(patsubst %.c,%.o,$(f)); \
	)
else ifdef USE_LDD
LDFLAGS += -DUSE_LD=1
$(RESOURCES_O): $(RESOURCES)
	@$(ECHO) "Building Resource object $@$(reset)"
	$(QUIET)cd $(RESOURCES_DIR) && $(LD) -r -b binary -m $(LDEMULATION) $(patsubst %.o,%.png,$@) -o ../../Build/$@
else
LDFLAGS += -DUSE_LD=1
$(RESOURCES_O): $(RESOURCES)
	@$(ECHO) "Building Resource object $@$(reset)"
	$(QUIET)cd $(RESOURCES_DIR) && $(LD) -r -b binary -z noexecstack $(patsubst %.o,%.png,$@) -o ../../Build/$@
endif

$(SVGRESOURCES_C): $(SVGRESOURCES)
	@$(ECHO) "Building SVG Resource object $@ $(reset)"
	$(QUIET)@cd $(RESOURCES_DIR) && echo "const char* $(patsubst %.c,%_svg,$@) = \""| tr -d '\r\n' > ../../Build/$@
	$(QUIET)@cd $(RESOURCES_DIR) && base64  $(patsubst %.c,%.svg,$@) | tr -d '\r\n' >> ../../Build/$@
	$(QUIET)@cd $(RESOURCES_DIR) && echo "\";" >> ../../Build/$@
	$(QUIET)$(CC) $(CFLAGS) -c $@ -o $(patsubst %.c,%.o,$@)

$(DIALOG_OBJ): $(DIALOG_SOURCES)
	@$(ECHO) "Building object file $@ $(reset)"
	$(QUIET)$(CC) $(CFLAGS) -MMD -Wall -c $(addprefix $(DIALOG_DIR),$(patsubst %.o,%.c,$@)) -o $@ $(INCLUDES) $(LDFLAGS)

$(WIDGET_OBJ): $(WIDGET_SOURCES)
	@$(ECHO) "Building object file $@ $(reset)"
	$(QUIET)$(CC) $(CFLAGS) -MMD -Wall -c $(addprefix $(WIDGET_DIR),$(patsubst %.o,%.c,$@)) -o $@ $(INCLUDES) $(LDFLAGS)

$(LIB_OBJ): $(LIB_SOURCES)
	@$(ECHO) "Building object file $@ $(reset)"
	$(QUIET)$(CC) $(CFLAGS) -MMD -Wall -c $(addprefix $(LIB_DIR),$(patsubst %.o,%.c,$@)) -o $@ $(INCLUDES) $(LDFLAGS)

-include $(DEP)

xputty.pc: xputty.pc.in
ifeq ($(TARGET), Linux)
	$(QUIET)sed 's;PATH;$(PREFIX);' $< >$@
endif

libxputty.$(STATIC_LIB_EXT): $(SVGRESOURCES_C) $(LIB_OBJ) $(WIDGET_OBJ) $(DIALOG_OBJ) $(XDG_OBJ)
	@$(B_ECHO) "Build static library $@ $(reset)"
	$(QUIET)$(AR) rcs libxputty.$(STATIC_LIB_EXT) $(LIB_OBJ) $(WIDGET_OBJ) $(DIALOG_OBJ) $(RESOURCES_OBJ)  $(SVGRESOURCES_OBJ) $(XDG_OBJ)
	$(QUIET)mkdir -p $(RELEASE_DIR)include/
	$(QUIET)cp $(HEADER_DIR)*.h $(RELEASE_DIR)include/
	$(QUIET)cp $(WIDGET_HEADER_DIR)*.h $(RELEASE_DIR)include/
	$(QUIET)cp $(DIALOG_HEADER_DIR)*.h $(RELEASE_DIR)include/
	$(QUIET)cp $(RESOURCEHEADER) $(RELEASE_DIR)include/
	$(QUIET)cp config.h $(RELEASE_DIR)include/
ifeq ($(TARGET), Linux)
	$(QUIET)cp $(XDG_DIR)*.h $(RELEASE_DIR)include/
endif
	$(QUIET)cp -r $(LIB_DIR)lv2_plugin $(RELEASE_DIR)
	$(QUIET)cp libxputty.$(STATIC_LIB_EXT) $(RELEASE_DIR)

libxputty.$(LIB_EXT): xputty.pc libxputty.$(STATIC_LIB_EXT)
	@$(B_ECHO) "Compile shared library $@ $(reset)"
	$(QUIET)$(CC) -shared -Wl,-soname,libxputty.$(LIB_EXT).1 -o libxputty.$(LIB_EXT).1.0 $(LIB_OBJ) $(WIDGET_OBJ) $(DIALOG_OBJ) $(RESOURCES_OBJ) $(XDG_OBJ)
	$(QUIET)cp libxputty.$(LIB_EXT).1.0 $(RELEASE_DIR)
	$(QUIET)ln -sf libxputty.$(LIB_EXT).1.0 libxputty.$(LIB_EXT).1
	$(QUIET)ln -sf libxputty.$(LIB_EXT).1 libxputty.$(LIB_EXT)
	$(QUIET)cp -Pf libxputty.$(LIB_EXT).1 $(RELEASE_DIR)
	$(QUIET)cp -Pf libxputty.$(LIB_EXT) $(RELEASE_DIR)
ifeq ($(TARGET), Linux)
	$(QUIET)cp xputty.pc $(RELEASE_DIR)
endif

shared: libxputty.$(LIB_EXT)
	@:

doc:
	@:

mod:
	@:

install: shared
ifneq ("$(wildcard $(RELEASE_DIR))","")
	@$(B_ECHO) "Install libxputty libraries $(reset)"
	$(QUIET)mkdir -p $(DESTDIR)$(INCLUDE_DIR)xputty/
	$(QUIET)mkdir -p $(DESTDIR)$(INSTALL_DIR)
	$(QUIET)mkdir -p $(DESTDIR)$(SHARE_DIR)pkgconfig/
	$(QUIET)cp $(RELEASE_DIR)include/*.h $(DESTDIR)$(INCLUDE_DIR)xputty/
	$(QUIET)cp $(RELEASE_DIR)*.$(LIB_EXT).1.0 $(DESTDIR)$(INSTALL_DIR)
	$(QUIET)cp -Pf $(RELEASE_DIR)*.$(LIB_EXT).1 $(DESTDIR)$(INSTALL_DIR)
	$(QUIET)cp -Pf $(RELEASE_DIR)*.$(LIB_EXT) $(DESTDIR)$(INSTALL_DIR)
	$(QUIET)cp $(RELEASE_DIR)libxputty.$(STATIC_LIB_EXT) $(DESTDIR)$(INSTALL_DIR)
	$(QUIET)cp $(RELEASE_DIR)xputty.pc $(DESTDIR)$(SHARE_DIR)pkgconfig/
	@$(B_ECHO) "=================== DONE =======================$(reset)"
else
	@$(R_ECHO) "you must run 'make' first$(reset)"
endif

uninstall:
	@rm -rf $(DESTDIR)$(INSTALL_DIR)libxputty.$(LIB_EXT) $(DESTDIR)$(INSTALL_DIR)libxputty.$(LIB_EXT).1 \
	$(DESTDIR)$(INSTALL_DIR)libxputty.$(LIB_EXT).1.0 $(DESTDIR)$(INSTALL_DIR)libxputty.$(STATIC_LIB_EXT)
	@rm -rf $(DESTDIR)$(INCLUDE_DIR)xputty/
	@rm -rf $(DESTDIR)$(SHARE_DIR)pkgconfig/xputty.pc

=== debian/changelog ===
loopino (0.5.0-0ubuntu1) resolute; urgency=medium

  * Initial release. (LP: #2137383)

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Fri, 02 Jan 2026 17:22:06 -0800

=== debian/control ===
Source: loopino
Section: sound
Priority: optional
Maintainer: Erich Eickmeyer <eeickmeyer@ubuntu.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libsndfile1-dev,
 libfftw3-dev,
 libcairo2-dev,
 libx11-dev,
 librubberband-dev,
 libjack2-dev | libjack-dev,
 libasound2-dev,
 pkgconf
Standards-Version: 4.7.2
Homepage: https://github.com/brummer10/Loopino

Package: loopino
Architecture: all
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Recommends:
 loopino-standalone,
 loopino-vst2,
 loopino-clap
Description: Lightweight audio sampler (Metapackage)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This is a metapackage that installs all Loopino variants: standalone
 application, VST2 plugin, and CLAP plugin. If you only need a specific
 variant, consider installing the corresponding package directly
 (loopino-standalone, loopino-vst2, or loopino-clap).

Package: loopino-standalone
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Lightweight audio sampler (Standalone Application)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This package provides the Loopino standalone application.

Package: loopino-vst
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Lightweight audio sampler (VST2 Plugin)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This package provides the Loopino VST2 plugin.

Package: loopino-clap
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Lightweight audio sampler (CLAP Plugin)
 Loopino is a lightweight audio sampler. It allows you to load, trim, and loop
 audio files with precision, making it ideal for crafting seamless sample
 loops. With a clean, minimal interface, Loopino fits perfectly into any audio
 workflow — whether for sound design, live performance, or creative sampling
 experiments.
 .
 This package provides the Loopino CLAP plugin.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/buildflags.mk

# Enable verbose make output during package builds
export V = 1
# Enable debhelper verbose output
export DH_VERBOSE = 1

# Force using ld-based resource embedding instead of xxd-generated C arrays
export USE_LDD = 1
# ensure RELRO is applied to linked binaries (fix lintian hardening-no-relro)
LDFLAGS += -Wl,-z,relro
export LDFLAGS

%:
	dh $@

execute_before_dh_auto_build:
	rm -rf rubberband

override_dh_auto_build:
	$(MAKE)
	$(MAKE) vst2
	$(MAKE) clap

override_dh_auto_install:
# Run upstream install directly into debian/tmp with INSTALL=install
# to avoid install-time stripping (prevent --strip-program=true).
	$(MAKE) install DESTDIR=$(CURDIR)/debian/tmp INSTALL="install" V=1

=== debian/watch ===
Version: 5
Source: https://api.github.com/repos/brummer10/Loopino/releases?per_page=100
Matching-Pattern: https://github.com/brummer10/Loopino/releases/download/v[^/]+/Loopino-v@ANY_VERSION@-src\.tar\.xz
Filename-Mangle: s%.*/Loopino-v@ANY_VERSION@-src\.tar\.xz%loopino-$1.tar.xz%
Search-Mode: plain
